unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure Image1Paint(Sender: TObject);
  private
    procedure Bild_in_Image_Laden(AImage:TImage; Datei_mit_Pfad:String;
      Grafik_aus_Zwischenablage:Boolean);
    procedure Image_Rechteck_Zeichnen(AImage:TImage; Pinselfarbe:TColor;
      Linienstaerke,X_Start,Y_Start,X_Laenge,Y_Laenge:Integer);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  clipbrd;

const
  BILD_DATEI = 'cheetah.jpg';

procedure TForm1.Image_Rechteck_Zeichnen(AImage:TImage;
  Pinselfarbe:TColor;
  Linienstaerke,X_Start,Y_Start,X_Laenge,Y_Laenge:Integer);
var
  I: Integer;
begin
  if Pinselfarbe = clBlue then
    Pinselfarbe := clRed;

  { siehe unten...
  I := 0;
  AImage.Canvas.pen.Width   := Linienstaerke;
  AImage.Canvas.Pen.Color   := Pinselfarbe;
  AImage.Canvas.Brush.Color := Pinselfarbe;
  while I <> Linienstaerke do
  begin
    AImage.Canvas.FrameRect(X_Start, Y_Start, X_Start + X_Laenge, Y_Start + Y_Laenge);
    X_Start  := X_Start  + 1;
    Y_Start  := Y_Start  + 1;
    X_Laenge := X_Laenge - 2;
    Y_Laenge := Y_Laenge - 2;
    I := I + 1;
  end;
  }

  // besser:
  AImage.Canvas.Pen.Width := Linienstaerke;
  AImage.Canvas.Pen.Color := PinselFarbe;
  AImage.Canvas.Brush.Style := bsClear;  // Rechteck nicht füllen
  AImage.Canvas.Rectangle(X_Start, Y_Start, X_Start+X_Laenge, Y_Start + Y_Laenge);
end;


procedure TForm1.Bild_in_Image_Laden(AImage:TImage;Datei_mit_Pfad:String;Grafik_aus_Zwischenablage:Boolean);
begin
  {
  AImage.AutoSize := True;           // warum?
  AImage.Proportional := True;
  }
  if not Grafik_aus_Zwischenablage then
  begin
    AImage.Picture.LoadFromFile(Datei_mit_Pfad);
  end
  else
  begin
    AImage.Picture.Bitmap.LoadFromClipboardFormat(CF_BITMAP);
  end;
    {
  AImage.AutoSize := False;   // warum?
  AImage.Proportional:= False;
  }
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Bild_in_Image_Laden(Image1, BILD_DATEI, false);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Bild_in_Image_Laden(Image1, '', true);
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  Image1.Invalidate;  // Image1 neu zeichnen
end;

procedure TForm1.Image1Paint(Sender: TObject);
begin
  // Das Hintergrundbild wird automatisch ausgegeben.
  // Hier steht nur, was über das Hintergrundbild gemalt werden soll
  if Checkbox1.Checked then
    Image_Rechteck_Zeichnen(Image1, clRed, 5, 10, 10, 100, 100);
end;

end.

